// components/services/screen_ai/public/mojom/screen_ai_service.mojom-shared-internal.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_SCREEN_AI_PUBLIC_MOJOM_SCREEN_AI_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_SERVICES_SCREEN_AI_PUBLIC_MOJOM_SCREEN_AI_SERVICE_MOJOM_SHARED_INTERNAL_H_
#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "skia/public/mojom/bitmap.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom-shared-internal.h"
#include "ui/accessibility/mojom/ax_tree_update.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}


namespace screen_ai::mojom {
namespace internal {
class VisualAnnotation_Data;
class LineBox_Data;
class WordBox_Data;

struct Direction_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  VisualAnnotation_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::LineBox_Data>>> lines;

 private:
  friend class mojo::internal::MessageFragment<VisualAnnotation_Data>;

  VisualAnnotation_Data();
  ~VisualAnnotation_Data() = delete;
};
static_assert(sizeof(VisualAnnotation_Data) == 16,
              "Bad sizeof(VisualAnnotation_Data)");
// Used by VisualAnnotation::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct VisualAnnotation_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  VisualAnnotation_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~VisualAnnotation_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<VisualAnnotation_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    VisualAnnotation_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  LineBox_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WordBox_Data>>> words;
  mojo::internal::Pointer<mojo::internal::String_Data> text_line;
  mojo::internal::Pointer<mojo::internal::String_Data> language;
  int32_t block_id;
  int32_t order_within_block;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounding_box;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> baseline_box;
  float angle;
  uint8_t padfinal_[4];

 private:
  friend class mojo::internal::MessageFragment<LineBox_Data>;

  LineBox_Data();
  ~LineBox_Data() = delete;
};
static_assert(sizeof(LineBox_Data) == 64,
              "Bad sizeof(LineBox_Data)");
// Used by LineBox::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct LineBox_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  LineBox_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~LineBox_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<LineBox_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    LineBox_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  WordBox_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> word;
  uint8_t dictionary_word : 1;
  uint8_t has_space_after : 1;
  uint8_t pad2_[3];
  int32_t direction;
  mojo::internal::Pointer<mojo::internal::String_Data> language;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounding_box;

 private:
  friend class mojo::internal::MessageFragment<WordBox_Data>;

  WordBox_Data();
  ~WordBox_Data() = delete;
};
static_assert(sizeof(WordBox_Data) == 40,
              "Bad sizeof(WordBox_Data)");
// Used by WordBox::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WordBox_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WordBox_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WordBox_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<WordBox_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WordBox_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal

}  // screen_ai::mojom

#endif  // COMPONENTS_SERVICES_SCREEN_AI_PUBLIC_MOJOM_SCREEN_AI_SERVICE_MOJOM_SHARED_INTERNAL_H_