// services/network/public/mojom/variants_header.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_VARIANTS_HEADER_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_VARIANTS_HEADER_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/variants_header.mojom-features.h"
#include "services/network/public/mojom/variants_header.mojom-shared.h"
#include "services/network/public/mojom/variants_header.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace network::mojom::blink {








class BLINK_PLATFORM_EXPORT VariantsHeader {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<VariantsHeader, T>::value>;
  using DataView = VariantsHeaderDataView;
  using Data_ = internal::VariantsHeader_Data;

  template <typename... Args>
  static VariantsHeaderPtr New(Args&&... args) {
    return VariantsHeaderPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static VariantsHeaderPtr From(const U& u) {
    return mojo::TypeConverter<VariantsHeaderPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VariantsHeader>::Convert(*this);
  }


  VariantsHeader();

  VariantsHeader(
      const WTF::String& name,
      WTF::Vector<WTF::String> available_values);


  ~VariantsHeader();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VariantsHeaderPtr>
  VariantsHeaderPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VariantsHeader::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VariantsHeader::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VariantsHeader_UnserializedMessageContext<
            UserType, VariantsHeader::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<VariantsHeader::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return VariantsHeader::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VariantsHeader_UnserializedMessageContext<
            UserType, VariantsHeader::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VariantsHeader::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::String name;
  
  WTF::Vector<WTF::String> available_values;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, VariantsHeader::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
VariantsHeaderPtr VariantsHeader::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(available_values)
  );
}

template <typename T, VariantsHeader::EnableIfSame<T>*>
bool VariantsHeader::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->available_values, other_struct.available_values))
    return false;
  return true;
}

template <typename T, VariantsHeader::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.available_values < rhs.available_values)
    return true;
  if (rhs.available_values < lhs.available_values)
    return false;
  return false;
}


}  // network::mojom::blink

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::VariantsHeader::DataView,
                                         ::network::mojom::blink::VariantsHeaderPtr> {
  static bool IsNull(const ::network::mojom::blink::VariantsHeaderPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::VariantsHeaderPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::VariantsHeader::name)& name(
      const ::network::mojom::blink::VariantsHeaderPtr& input) {
    return input->name;
  }

  static const decltype(::network::mojom::blink::VariantsHeader::available_values)& available_values(
      const ::network::mojom::blink::VariantsHeaderPtr& input) {
    return input->available_values;
  }

  static bool Read(::network::mojom::blink::VariantsHeader::DataView input, ::network::mojom::blink::VariantsHeaderPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_VARIANTS_HEADER_MOJOM_BLINK_H_