// third_party/blink/public/mojom/push_messaging/push_messaging_status.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PUSH_MESSAGING_PUSH_MESSAGING_STATUS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PUSH_MESSAGING_PUSH_MESSAGING_STATUS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/push_messaging/push_messaging_status.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink::mojom {


}  // blink::mojom

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class PushEventStatus : int32_t {
  
  SUCCESS = 0,
  
  UNKNOWN_APP_ID = 2,
  
  PERMISSION_DENIED = 3,
  
  NO_SERVICE_WORKER = 4,
  
  SERVICE_WORKER_ERROR = 5,
  
  EVENT_WAITUNTIL_REJECTED = 6,
  
  TIMEOUT = 7,
  
  PERMISSION_REVOKED_ABUSIVE = 8,
  
  NO_APP_LEVEL_PERMISSION_IGNORE = 9,
  
  NO_APP_LEVEL_PERMISSION_UNSUBSCRIBE = 10,
  
  PERMISSION_REVOKED_DISRUPTIVE = 11,
  kMinValue = 0,
  kMaxValue = 11,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, PushEventStatus value);
inline bool IsKnownEnumValue(PushEventStatus value) {
  return internal::PushEventStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class PushGetRegistrationStatus : int32_t {
  
  SUCCESS = 0,
  
  SERVICE_NOT_AVAILABLE = 1,
  
  STORAGE_ERROR = 2,
  
  REGISTRATION_NOT_FOUND = 3,
  
  INCOGNITO_REGISTRATION_NOT_FOUND = 4,
  
  STORAGE_CORRUPT = 6,
  
  RENDERER_SHUTDOWN = 7,
  
  NO_LIVE_SERVICE_WORKER = 8,
  kMinValue = 0,
  kMaxValue = 8,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, PushGetRegistrationStatus value);
inline bool IsKnownEnumValue(PushGetRegistrationStatus value) {
  return internal::PushGetRegistrationStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class PushRegistrationStatus : int32_t {
  
  SUCCESS_FROM_PUSH_SERVICE = 0,
  
  NO_SERVICE_WORKER = 1,
  
  SERVICE_NOT_AVAILABLE = 2,
  
  LIMIT_REACHED = 3,
  
  PERMISSION_DENIED = 4,
  
  SERVICE_ERROR = 5,
  
  NO_SENDER_ID = 6,
  
  STORAGE_ERROR = 7,
  
  SUCCESS_FROM_CACHE = 8,
  
  NETWORK_ERROR = 9,
  
  INCOGNITO_PERMISSION_DENIED = 10,
  
  PUBLIC_KEY_UNAVAILABLE = 11,
  
  MANIFEST_EMPTY_OR_MISSING = 12,
  
  SENDER_ID_MISMATCH = 13,
  
  STORAGE_CORRUPT = 14,
  
  RENDERER_SHUTDOWN = 15,
  
  SUCCESS_NEW_SUBSCRIPTION_FROM_PUSH_SERVICE = 16,
  
  UNSUPPORTED_GCM_SENDER_ID = 17,
  kMinValue = 0,
  kMaxValue = 17,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, PushRegistrationStatus value);
inline bool IsKnownEnumValue(PushRegistrationStatus value) {
  return internal::PushRegistrationStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class PushUnregistrationReason : int32_t {
  
  UNKNOWN = 0,
  
  JAVASCRIPT_API = 1,
  
  PERMISSION_REVOKED = 2,
  
  DELIVERY_UNKNOWN_APP_ID = 3,
  
  DELIVERY_PERMISSION_DENIED = 4,
  
  DELIVERY_NO_SERVICE_WORKER = 5,
  
  GCM_STORE_RESET = 6,
  
  SERVICE_WORKER_UNREGISTERED = 7,
  
  SUBSCRIBE_STORAGE_CORRUPT = 8,
  
  GET_SUBSCRIPTION_STORAGE_CORRUPT = 9,
  
  SERVICE_WORKER_DATABASE_WIPED = 10,
  
  SUBSCRIPTION_EXPIRED = 11,
  
  REFRESH_FINISHED = 12,
  
  PERMISSION_REVOKED_ABUSIVE = 13,
  
  NO_APP_LEVEL_PERMISSION = 14,
  
  PERMISSION_REVOKED_DISRUPTIVE = 15,
  kMinValue = 0,
  kMaxValue = 15,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, PushUnregistrationReason value);
inline bool IsKnownEnumValue(PushUnregistrationReason value) {
  return internal::PushUnregistrationReason_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class PushUnregistrationStatus : int32_t {
  
  SUCCESS_UNREGISTERED = 0,
  
  SUCCESS_WAS_NOT_REGISTERED = 1,
  
  PENDING_NETWORK_ERROR = 2,
  
  NO_SERVICE_WORKER = 3,
  
  SERVICE_NOT_AVAILABLE = 4,
  
  PENDING_SERVICE_ERROR = 5,
  
  STORAGE_ERROR = 6,
  
  NETWORK_ERROR = 7,
  kMinValue = 0,
  kMaxValue = 7,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, PushUnregistrationStatus value);
inline bool IsKnownEnumValue(PushUnregistrationStatus value) {
  return internal::PushUnregistrationStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::PushEventStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::PushEventStatus> {};

template <>
struct hash<::blink::mojom::PushGetRegistrationStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::PushGetRegistrationStatus> {};

template <>
struct hash<::blink::mojom::PushRegistrationStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::PushRegistrationStatus> {};

template <>
struct hash<::blink::mojom::PushUnregistrationReason>
    : public mojo::internal::EnumHashImpl<::blink::mojom::PushUnregistrationReason> {};

template <>
struct hash<::blink::mojom::PushUnregistrationStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::PushUnregistrationStatus> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PushEventStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::PushEventStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::PushEventStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PushGetRegistrationStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::PushGetRegistrationStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::PushGetRegistrationStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PushRegistrationStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::PushRegistrationStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::PushRegistrationStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PushUnregistrationReason, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::PushUnregistrationReason, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::PushUnregistrationReason>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PushUnregistrationStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::PushUnregistrationStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::PushUnregistrationStatus>(input)), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {


}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::PushEventStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::PushEventStatus value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::PushGetRegistrationStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::PushGetRegistrationStatus value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::PushRegistrationStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::PushRegistrationStatus value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::PushUnregistrationReason> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::PushUnregistrationReason value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::PushUnregistrationStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::PushUnregistrationStatus value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PUSH_MESSAGING_PUSH_MESSAGING_STATUS_MOJOM_SHARED_H_